<section *ngIf="tableName === 'hidden' && dataSource?.data.length > 0" name="hiddenStationsToggle" fxLayout="row" fxLayoutAlign="end center">
  <button type="button" mat-raised-button (click)="tableHidden = !tableHidden">
    <mat-icon>visibility_off</mat-icon>
    <span *ngIf="tableHidden">{{ 'COMPONENTS.TANKDATEN.SHOWHIDDEN' | translate }}</span>
    <span *ngIf="!tableHidden">{{ 'COMPONENTS.TANKDATEN.HIDEHIDDEN' | translate }}</span>
  </button>
</section>

<section fxLayout="column" fxLayoutGap="20px" class="p12A" [fxHide]="tableHidden">
  <div class="dark-caption-wrapper" fxLayout="column" fxLayoutAlign="center center">
    <h3 class="table-caption" fxLayoutAlign="start center">{{ title }}</h3>
    <small class="text-gray" *ngIf="subtitle">{{ subtitle }}</small>
  </div>

  <table mat-table [dataSource]="dataSource" matSort #sort="matSort" class="table-paginator-margin">
    <!-- name Column -->
    <ng-container matColumnDef="name">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ 'COMPONENTS.TANKDATEN.TABLE.NAME' | translate }}</th>
      <td mat-cell *matCellDef="let element">{{ element.name | ReplaceEmpty }}</td>
    </ng-container>

    <!-- distance Column -->
    <ng-container matColumnDef="dist">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ 'COMPONENTS.TANKDATEN.TABLE.DIST' | translate }}</th>
      <td mat-cell *matCellDef="let element" [ngClass]="getStationNearClass(element.dist)" matTooltip="{{ 'COMPONENTS.TANKDATEN.' + getStationNearTooltip(element.dist) | translate }}">
        {{ element.dist | ReplaceEmpty }} km
      </td>
    </ng-container>

    <!-- e5 Column -->
    <ng-container matColumnDef="e5">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ 'COMPONENTS.TANKDATEN.TABLE.E5' | translate }}</th>
      <td
        mat-cell
        *matCellDef="let element"
        class="price-cell"
        [ngClass]="{ 'text-green text-bold': element.id === stationService.minE5_Id, 'text-red text-bold': element.id === stationService.maxE5_Id }"
      >
        <section *ngIf="searchInputService.fuel === 'all' || searchInputService.fuel === 'e5'">
          <div *ngFor="let fuel of element.fuels">
            <div *ngIf="fuel.name === 'Super E5'" [innerHTML]="commonService.getLastCharSup(fuel.price)"></div>
          </div>
        </section>
      </td>
    </ng-container>

    <!-- e10 Column -->
    <ng-container matColumnDef="e10">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ 'COMPONENTS.TANKDATEN.TABLE.E10' | translate }}</th>
      <td
        mat-cell
        *matCellDef="let element"
        class="price-cell"
        [ngClass]="{ 'text-green text-bold': element.id === stationService.minE10_Id, 'text-red text-bold': element.id === stationService.maxE10_Id }"
      >
        <section *ngIf="searchInputService.fuel === 'all' || searchInputService.fuel === 'e10'">
          <div *ngFor="let fuel of element.fuels">
            <div *ngIf="fuel.name === 'Super E10'" [innerHTML]="commonService.getLastCharSup(fuel.price)"></div>
          </div>
        </section>
      </td>
    </ng-container>

    <!-- diesel Column -->
    <ng-container matColumnDef="diesel">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ 'COMPONENTS.TANKDATEN.TABLE.DIESEL' | translate }}</th>
      <td
        mat-cell
        *matCellDef="let element"
        class="price-cell"
        [ngClass]="{ 'text-green text-bold': element.id === stationService.minDiesel_Id, 'text-red text-bold': element.id === stationService.maxDiesel_Id }"
      >
        <section *ngIf="searchInputService.fuel === 'all' || searchInputService.fuel === 'diesel'">
          <div *ngFor="let fuel of element.fuels">
            <div *ngIf="fuel.name === 'Diesel'" [innerHTML]="commonService.getLastCharSup(fuel.price)"></div>
          </div>
        </section>
      </td>
    </ng-container>

    <!-- aktionen mobile Column -->
    <ng-container matColumnDef="actions_mobile" class="actions_mobile">
      <th mat-header-cell *matHeaderCellDef>{{ 'COMPONENTS.TANKDATEN.TABLE.MORE' | translate }}</th>
      <td mat-cell *matCellDef="let element">
        <div fxLayout="row" fxLayoutAlign="start center"></div>

        <section *ngIf="tableName === 'overview'">
          <button mat-icon-button [matMenuTriggerFor]="aktionenUebersicht"><mat-icon>more_horiz</mat-icon></button>
          <mat-menu #aktionenUebersicht="matMenu">
            <button mat-menu-item color="primary" (click)="loadDetails(element)" type="button"><mat-icon>info</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.SHOWDETAILS' | translate }}</button>
            <button mat-menu-item (click)="setFavorite(element)" type="button">
              <mat-icon class="list-star" [ngClass]="getFavoriteStarColor(element)">star</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.' + getFavoritText(element) | translate }}
            </button>
            <button mat-menu-item (click)="hideStation(element)" type="button"><mat-icon>visibility_off</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.SHOWDETAILS' | translate }}</button>
          </mat-menu>
        </section>

        <section *ngIf="tableName === 'favorites'">
          <button mat-icon-button [matMenuTriggerFor]="aktionenFavoriten"><mat-icon>more_horiz</mat-icon></button>
          <mat-menu #aktionenFavoriten="matMenu">
            <button mat-menu-item (click)="loadDetails(element)" type="button"><mat-icon>info</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.SHOWDETAILS' | translate }}</button>
            <button mat-menu-item (click)="deleteFromFavorites(element)" type="button"><mat-icon>close</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.REMOVEFAV' | translate }}</button>
          </mat-menu>
        </section>

        <section *ngIf="tableName === 'hidden'">
          <button mat-icon-button [matMenuTriggerFor]="aktionenHidden"><mat-icon>more_horiz</mat-icon></button>
          <mat-menu #aktionenHidden="matMenu">
            <button mat-menu-item color="primary" (click)="loadDetails(element)" type="button"><mat-icon>info</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.SHOWDETAILS' | translate }}</button>
            <button mat-menu-item (click)="showStation(element)" type="button"><mat-icon>visibility_off</mat-icon> {{ 'COMPONENTS.TANKDATEN.TABLE.SHOWSTATION' | translate }}</button>
          </mat-menu>
        </section>
      </td>
    </ng-container>

    <!-- aktionen normal Column -->
    <ng-container matColumnDef="actions_normal" class="actions_normal">
      <th mat-header-cell *matHeaderCellDef>{{ 'COMPONENTS.TANKDATEN.TABLE.MORE' | translate }}</th>
      <td mat-cell *matCellDef="let element">
        <div fxLayout="row" fxLayoutAlign="start center">
          <button mat-icon-button color="primary" (click)="loadDetails(element)" type="button" matTooltip="{{ 'COMPONENTS.TANKDATEN.TABLE.SHOWDETAILS' | translate }}">
            <mat-icon>info</mat-icon>
          </button>

          <section *ngIf="tableName === 'overview'">
            <button mat-icon-button matTooltip="{{ 'COMPONENTS.TANKDATEN.TABLE.' + getFavoritText(element) | translate }}" (click)="setFavorite(element)" type="button">
              <mat-icon class="list-star" [ngClass]="getFavoriteStarColor(element)">star</mat-icon>
            </button>
            <button mat-icon-button class="text-gray list-visibility" (click)="hideStation(element)" type="button" matTooltip="{{ 'COMPONENTS.TANKDATEN.TABLE.HIDESTATION_LONG' | translate }}">
              <mat-icon>visibility_off</mat-icon>
            </button>
          </section>

          <section *ngIf="tableName === 'favorites'">
            <button mat-icon-button color="warn" (click)="deleteFromFavorites(element)" matTooltip="{{ 'COMPONENTS.TANKDATEN.TABLE.REMOVESTATION' | translate }}">
              <mat-icon>close</mat-icon>
            </button>
          </section>

          <section *ngIf="tableName === 'hidden'">
            <button type="button" mat-icon-button matTooltip="{{ 'COMPONENTS.TANKDATEN.TABLE.SHOWSTATION_LONG' | translate }}" (click)="showStation(element)" class="text-gray">
              <mat-icon>visibility</mat-icon>
            </button>
          </section>
        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="cols"></tr>
    <tr mat-row *matRowDef="let row; columns: cols"></tr>
  </table>

  <mat-paginator #paginator [pageSizeOptions]="[10, 25, 50, 100]"></mat-paginator>
</section>
